#include <Wire.h>
#include <Adafruit_PWMServoDriver.h> // Librería shield servos

// De esta manera le llamamos a la direccion por defecto 0x40
Adafruit_PWMServoDriver pwm = Adafruit_PWMServoDriver();
// Se puede llamar a la direccion que se quiera de esta forma
// Adafruit_PWMServoDriver pwm = Adafruit_PWMServoDriver(0x41);

// Dependiendo del tipo de servo el pulso máximo y mínimo es diferente
// Lo preferible es que sea el máximo posible sin llegar a hacer tope

#define SERVOMIN  150 // Minimo (sobre 4096)
#define SERVOMAX  550 // Maximo (sobre 4096)


const unsigned short h1 = 0; //Hombro extremidad 1
const unsigned short p1 = 1; //Pata extremidad 1
const unsigned short h2 = 4; //Hombro extremidad 2
const unsigned short p2 = 5; //Pata extremidad 2
const unsigned short h3 = 8; //Hombro extremidad 3
const unsigned short p3 = 9; //Pata extremidad 3
const unsigned short h4 = 12; //Hombro extremidad 4
const unsigned short p4 = 13; //Pata extremidad 4

void setup()
{
  pwm.begin();
  pwm.setPWMFreq(60);  // Los servos funcionan a ~60 Hz
}

void loop()
{
  depie();
  delay(3000);
  tumbar();
  delay(3000);
  depie();
  delay(3000);
  sentar();
  delay(3000);
  inclinar();
  delay(3000);
  inclinarder();
  delay(3000);
  inclinarizq();
  delay(3000);
  hola();
  delay(3000);
  andar();
  delay(3000);
  atras();
  delay(3000);
  girarderecha();
  delay(3000);
  girarizquierda();
  delay(3000);
}

// Funcion para tumbar el robot
void tumbar()
{
  pwm.setPWM(h1, 0, 350);
  pwm.setPWM(h2, 0, 350);
  pwm.setPWM(h3, 0, 350);
  pwm.setPWM(h4, 0, 350);

  pwm.setPWM(p1, 0, 350);
  pwm.setPWM(p2, 0, 350);
  pwm.setPWM(p3, 0, 350);
  pwm.setPWM(p4, 0, 350);
}

// Funcion para poner de pie el robot
void depie()
{
  pwm.setPWM(h1, 0, 350);
  pwm.setPWM(h2, 0, 350);
  pwm.setPWM(h3, 0, 350);
  pwm.setPWM(h4, 0, 350);

  pwm.setPWM(p1, 0, 500);
  pwm.setPWM(p2, 0, 200);
  pwm.setPWM(p3, 0, 500);
  pwm.setPWM(p4, 0, 200);
}

// Funcion para sentar el robot
void sentar()
{
  pwm.setPWM(h1, 0, 300);
  pwm.setPWM(h2, 0, 400);
  pwm.setPWM(h3, 0, 350);
  pwm.setPWM(h4, 0, 350);

  pwm.setPWM(p1, 0, 350);
  pwm.setPWM(p2, 0, 350);
  pwm.setPWM(p3, 0, 500);
  pwm.setPWM(p4, 0, 200);
}

// Funcion para inclinar hacia delante el robot
void inclinar()
{
  pwm.setPWM(h1, 0, 350);
  pwm.setPWM(h2, 0, 350);
  pwm.setPWM(h3, 0, 300);
  pwm.setPWM(h4, 0, 400);

  pwm.setPWM(p1, 0, 500);
  pwm.setPWM(p2, 0, 200);
  pwm.setPWM(p3, 0, 350);
  pwm.setPWM(p4, 0, 350);
}

// Funcion para inclinar hacia la derecha el robot
void inclinarder()
{
  pwm.setPWM(h1, 0, 400);
  pwm.setPWM(h2, 0, 350);
  pwm.setPWM(h3, 0, 350);
  pwm.setPWM(h4, 0, 300);

  pwm.setPWM(p1, 0, 350);
  pwm.setPWM(p2, 0, 200);
  pwm.setPWM(p3, 0, 500);
  pwm.setPWM(p4, 0, 350);
}

// Funcion para inclinar hacia la izquierda el robot
void inclinarizq()
{
  pwm.setPWM(h1, 0, 350);
  pwm.setPWM(h2, 0, 300);
  pwm.setPWM(h3, 0, 400);
  pwm.setPWM(h4, 0, 350);

  pwm.setPWM(p1, 0, 500);
  pwm.setPWM(p2, 0, 350);
  pwm.setPWM(p3, 0, 350);
  pwm.setPWM(p4, 0, 200);
}


// Funcion para que salude el robot
void hola()
{
  //posicionamos el robot
  pwm.setPWM(h1, 0, 350);
  pwm.setPWM(h2, 0, 250);
  pwm.setPWM(h3, 0, 350);
  pwm.setPWM(h4, 0, 450);

  pwm.setPWM(p1, 0, 400);
  pwm.setPWM(p2, 0, 200);
  pwm.setPWM(p3, 0, 550);
  pwm.setPWM(p4, 0, 200);
  delay (500);



  pwm.setPWM(p3, 0, 250);
  delay (500);

  for (int i = 0; i < 3; i++)
  {
    pwm.setPWM(h3, 0, 250);
    delay (500);
    pwm.setPWM(h3, 0, 450);
    delay (500);
  }
  depie();
}

// Funcion para que ande el robot
void andar()
{

  pwm.setPWM(p1, 0, 450);
  pwm.setPWM(p3, 0, 450);
  delay (100);

  for (int i = 0; i < 10; i++)
  {
    pwm.setPWM(h1, 0, 400);
    pwm.setPWM(h3, 0, 300);
    delay (100);

    pwm.setPWM(p1, 0, 500);
    pwm.setPWM(p3, 0, 500);
    delay (100);

    pwm.setPWM(p2, 0, 250);
    pwm.setPWM(p4, 0, 250);
    delay(100);

    pwm.setPWM(h1, 0, 350);
    pwm.setPWM(h3, 0, 350);
    delay(100);

    pwm.setPWM(h2, 0, 300);
    pwm.setPWM(h4, 0, 400);
    delay (100);

    pwm.setPWM(p2, 0, 200);
    pwm.setPWM(p4, 0, 200);
    delay(100);

    pwm.setPWM(p1, 0, 450);
    pwm.setPWM(p3, 0, 450);
    delay (100);

    pwm.setPWM(h2, 0, 350);
    pwm.setPWM(h4, 0, 350);
    delay(100);
  }
  depie();
}

// Funcion para que ande el robot hacia atras
void atras()
{

  pwm.setPWM(p1, 0, 450);
  pwm.setPWM(p3, 0, 450);
  delay (100);

  for (int i = 0; i < 10; i++)
  {
    pwm.setPWM(h1, 0, 300);
    pwm.setPWM(h3, 0, 400);
    delay (100);

    pwm.setPWM(p1, 0, 500);
    pwm.setPWM(p3, 0, 500);
    delay (100);

    pwm.setPWM(p2, 0, 250);
    pwm.setPWM(p4, 0, 250);
    delay(100);

    pwm.setPWM(h1, 0, 350);
    pwm.setPWM(h3, 0, 350);
    delay(100);

    pwm.setPWM(h2, 0, 400);
    pwm.setPWM(h4, 0, 300);
    delay (100);

    pwm.setPWM(p2, 0, 200);
    pwm.setPWM(p4, 0, 200);
    delay(100);

    pwm.setPWM(p1, 0, 450);
    pwm.setPWM(p3, 0, 450);
    delay (100);

    pwm.setPWM(h2, 0, 350);
    pwm.setPWM(h4, 0, 350);
    delay(100);
  }
  depie();
}

// Funcion para que gire el robot a la derecha
void girarderecha()
{

  pwm.setPWM(p1, 0, 450);
  pwm.setPWM(p3, 0, 450);
  delay (100);

  for (int i = 0; i < 10; i++)
  {
    pwm.setPWM(h1, 0, 300);
    pwm.setPWM(h3, 0, 300);
    delay (100);

    pwm.setPWM(p1, 0, 500);
    pwm.setPWM(p3, 0, 500);
    delay (100);

    pwm.setPWM(p2, 0, 250);
    pwm.setPWM(p4, 0, 250);
    delay(100);

    pwm.setPWM(h1, 0, 350);
    pwm.setPWM(h3, 0, 350);
    delay(100);

    pwm.setPWM(h2, 0, 300);
    pwm.setPWM(h4, 0, 300);
    delay (100);

    pwm.setPWM(p2, 0, 200);
    pwm.setPWM(p4, 0, 200);
    delay(100);

    pwm.setPWM(p1, 0, 450);
    pwm.setPWM(p3, 0, 450);
    delay (100);

    pwm.setPWM(h2, 0, 350);
    pwm.setPWM(h4, 0, 350);
    delay(100);
  }
  depie();
}

// Funcion para que gire el robot hacia la izquierda
void girarizquierda()
{

  pwm.setPWM(p1, 0, 450);
  pwm.setPWM(p3, 0, 450);
  delay (100);

  for (int i = 0; i < 10; i++)
  {
    pwm.setPWM(h1, 0, 400);
    pwm.setPWM(h3, 0, 400);
    delay (100);

    pwm.setPWM(p1, 0, 500);
    pwm.setPWM(p3, 0, 500);
    delay (100);

    pwm.setPWM(p2, 0, 250);
    pwm.setPWM(p4, 0, 250);
    delay(100);

    pwm.setPWM(h1, 0, 350);
    pwm.setPWM(h3, 0, 350);
    delay(100);

    pwm.setPWM(h2, 0, 400);
    pwm.setPWM(h4, 0, 400);
    delay (100);

    pwm.setPWM(p2, 0, 200);
    pwm.setPWM(p4, 0, 200);
    delay(100);

    pwm.setPWM(p1, 0, 450);
    pwm.setPWM(p3, 0, 450);
    delay (100);

    pwm.setPWM(h2, 0, 350);
    pwm.setPWM(h4, 0, 350);
    delay(100);
  }
  depie();
}
